--  \\FREESIA4\FNDISEWORK\SAMPLE\...\IN4HEXSM.vhd
--  VHDL code created by Xilinx's StateCAD 7.1i
--  Thu Jun 29 16:50:55 2006

--  This VHDL code (for use with IEEE compliant tools) was generated using: 
--  enumerated state assignment with structured code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are speed optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY IN4HEXSM IS
	PORT (CLK,center_pulse,left_ack,left_pulse,RESET,right_ack,right_pulse: IN 
		std_logic;
		cursor_move,left_level,right_level : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF IN4HEXSM IS
	TYPE type_sreg1 IS (count_mode,cursor_move_stat);
	SIGNAL sreg1, next_sreg1 : type_sreg1;
	TYPE type_sreg2 IS (idle_lp_hold,left_level_high);
	SIGNAL sreg2, next_sreg2 : type_sreg2;
	TYPE type_sreg3 IS (idle_rp_hold,right_level_high);
	SIGNAL sreg3, next_sreg3 : type_sreg3;
	SIGNAL next_cursor_move,next_left_level,next_right_level : std_logic;
BEGIN
	PROCESS (CLK, RESET, next_sreg1, next_cursor_move)
	BEGIN
		IF ( RESET='1' ) THEN
			sreg1 <= count_mode;
			cursor_move <= '0';
		ELSIF CLK='1' AND CLK'event THEN
			sreg1 <= next_sreg1;
			cursor_move <= next_cursor_move;
		END IF;
	END PROCESS;

	PROCESS (CLK, RESET, next_sreg2, next_left_level)
	BEGIN
		IF ( RESET='1' ) THEN
			sreg2 <= idle_lp_hold;
			left_level <= '0';
		ELSIF CLK='1' AND CLK'event THEN
			sreg2 <= next_sreg2;
			left_level <= next_left_level;
		END IF;
	END PROCESS;

	PROCESS (CLK, RESET, next_sreg3, next_right_level)
	BEGIN
		IF ( RESET='1' ) THEN
			sreg3 <= idle_rp_hold;
			right_level <= '0';
		ELSIF CLK='1' AND CLK'event THEN
			sreg3 <= next_sreg3;
			right_level <= next_right_level;
		END IF;
	END PROCESS;

	PROCESS (sreg1,sreg2,sreg3,center_pulse,left_ack,left_pulse,right_ack,
		right_pulse)
	BEGIN
		next_cursor_move <= '0'; next_left_level <= '0'; next_right_level <= '0'; 

		next_sreg1<=count_mode;
		next_sreg2<=idle_lp_hold;
		next_sreg3<=idle_rp_hold;

		CASE sreg1 IS
			WHEN count_mode =>
				IF ( center_pulse='1' ) THEN
					next_sreg1<=cursor_move_stat;
					next_cursor_move<='1';
				 ELSE
					next_sreg1<=count_mode;
					next_cursor_move<='0';
				END IF;
			WHEN cursor_move_stat =>
				IF ( center_pulse='1' ) THEN
					next_sreg1<=count_mode;
					next_cursor_move<='0';
				 ELSE
					next_sreg1<=cursor_move_stat;
					next_cursor_move<='1';
				END IF;
			WHEN OTHERS =>
		END CASE;

		CASE sreg2 IS
			WHEN idle_lp_hold =>
				IF ( left_pulse='1' AND  (sreg1=cursor_move_stat)) THEN
					next_sreg2<=left_level_high;
					next_left_level<='1';
				 ELSE
					next_sreg2<=idle_lp_hold;
					next_left_level<='0';
				END IF;
			WHEN left_level_high =>
				IF ( left_ack='1' ) THEN
					next_sreg2<=idle_lp_hold;
					next_left_level<='0';
				 ELSE
					next_sreg2<=left_level_high;
					next_left_level<='1';
				END IF;
			WHEN OTHERS =>
		END CASE;

		CASE sreg3 IS
			WHEN idle_rp_hold =>
				IF ( right_pulse='1' AND  (sreg1=cursor_move_stat)) THEN
					next_sreg3<=right_level_high;
					next_right_level<='1';
				 ELSE
					next_sreg3<=idle_rp_hold;
					next_right_level<='0';
				END IF;
			WHEN right_level_high =>
				IF ( right_ack='1' ) THEN
					next_sreg3<=idle_rp_hold;
					next_right_level<='0';
				 ELSE
					next_sreg3<=right_level_high;
					next_right_level<='1';
				END IF;
			WHEN OTHERS =>
		END CASE;
	END PROCESS;
END BEHAVIOR;
