-- LCD̏̌̉E4A416iR[hB
-- ŏport04bit access(bit2),lcd_rs(bit1)lcd_rw(bit0)o͂B͂̂܂܃b`ďo͂B
-- lcd_rw0̏ꍇ(Write)̎́Axport18rbg̃f[^o͂B̃f[^󂯂4bit accessłȂ΃Xe[g}VUpper4bitALower4bitɕLCDW[ɏށB4bit accesŝƂUpper4bitƂȂB
-- port0o͂̃rbgATCǉbit3(pre_reset),read̏ꍇ͓ǂłINPUT߂Ŏ荞܂Ȃ΂ȂȂ̂ňxAport0bit31ɂport0ɏނƃXe[g}V[hĂ̂łINPUT߂picoblazeǂݍ(͂ȂA[h莞Ԍ
-- port1Ƀf[^o͂
-- port2̓C^[o^C}[̒l̐ݒɎgpB
-- |[g3right_ack
-- |[g4left_ack
-- ͂̃|[g0LCDreadf[^B
-- |[g1C^[o^C}[̃^CAEgtO(bit0)蓖ĂB
-- |[g2upper_4hex_datȁ8rbg
-- |[g3upper_4hex_datảʈ8rbg
-- |[g4lower_4hex_datȁ8rbg
-- |[g5lower_4hex_datả8rbg
-- |[g6̃rbg0right_levelArbg1left_levelArbg2cursor_move, rbg7`4̓J[\ʒu

-- 2006.05.16  Ver. 1.1 : ̓|[g3,4Ao̓|[g6,7ǉ

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library work;
use work.LCD_Display_pack.all;

entity LCD4HexDisp is
	port(
		clk : in std_logic;
		reset : in std_logic;
		upper_4hex_data : in std_logic_vector(15 downto 0); -- LCD̍s416i
		lower_4hex_data : in std_logic_vector(15 downto 0); -- LCD̍s416i
		lcd_d : inout std_logic_vector(7 downto 4);
		lcd_rs : out std_logic;
		lcd_rw : out std_logic;
		lcd_e : out std_logic;
		right_level : in std_logic; -- rightpXBright_ack܂1̂܂
		right_ack : out std_logic;
		left_level : in std_logic; -- leftpXBleft_ack܂1̂܂
		left_ack : out std_logic;
		cursor_position : in std_logic_vector(3 downto 0); -- J[\̈ʒuoCiŎBԍ3
		cursor_move : in std_logic; -- 1̎J[\̈ړA0̎w肳ꂽJEgAbvA_E
		cursor_return : out std_logic -- PicoBlazeJ[\[ɖ߂
	);
end LCD4HexDisp;

architecture RTL of LCD4HexDisp is
component kcpsm3 
	Port (
		address : out std_logic_vector(9 downto 0);
		instruction : in std_logic_vector(17 downto 0);
		port_id : out std_logic_vector(7 downto 0);
		write_strobe : out std_logic;
		out_port : out std_logic_vector(7 downto 0);
		read_strobe : out std_logic;
		in_port : in std_logic_vector(7 downto 0);
		interrupt : in std_logic;
		interrupt_ack : out std_logic;
		reset : in std_logic;
		clk : in std_logic);
end component;
-- Instraction ROM
component instrom
	port(
		address : in std_logic_vector(9 downto 0);
		instruction : out std_logic_vector(17 downto 0);
		clk : in std_logic
	);
end component;
component LCD_operation
	port(
		clk : in std_logic;
		reset : in std_logic;
		access4bit : in std_logic;
		port1_w_strobe : in std_logic;
		lcd_e : out std_logic;
		ope_is_idle : out std_logic;
		sel_lower : out std_logic
	);
end component;

signal address : std_logic_vector(9 downto 0);
signal instruction : std_logic_vector(17 downto 0);
signal port_id : std_logic_vector(7 downto 0);
signal write_strobe : std_logic;
signal out_port : std_logic_vector(7 downto 0);
signal read_strobe : std_logic;
signal in_port : std_logic_vector(7 downto 0);
signal logic0 : std_logic;
signal lcd_rs_node, lcd_rw_node, access4bit : std_logic;
signal wr_data : std_logic_vector(7 downto 0);
signal port1_w_strobe : std_logic;
signal pre_cnt : std_logic_vector(11 downto 0); -- _p
--signal pre_cnt : std_logic_vector(1 downto 0); -- V~[Vp
signal lcd_e_node : std_logic;
signal lcd_d_node : std_logic_vector(7 downto 4);
signal ope_is_idle, sel_lower : std_logic;
signal int_cnt_is_zero : std_logic;
signal int_cnt : std_logic_vector(7 downto 0);
signal input_data_latch : std_logic_vector(7 downto 0);
begin
	logic0 <= '0';
	cursor_return <= '0';
	
	kcpsm3_inst : kcpsm3 port map(
		address => address,
		instruction => instruction,
		port_id => port_id,
		write_strobe => write_strobe,
		out_port => out_port,
		read_strobe => read_strobe,
		in_port => in_port,
		interrupt => logic0,
		interrupt_ack => open,
		reset => reset,
		clk => clk
	);
	instrom_inst : instrom port map(
		address => address,
		instruction => instruction,
		clk => clk
	);
	
	LCD_operation_inst : LCD_operation port map(
		clk => clk,
		reset => reset,
		access4bit => access4bit,
		port1_w_strobe => port1_w_strobe,
		lcd_e => lcd_e_node,
		ope_is_idle => ope_is_idle,
		sel_lower => sel_lower
	);
	lcd_e <= lcd_e_node;
		
	-- o̓|[g0b`
	process(reset, clk) begin
		if reset='1' then
			lcd_rw_node <= '0';
			lcd_rs_node <= '0';
			access4bit <= '0';
		elsif clk'event and clk='1' then
			if write_strobe='1' and port_id=0 then
				lcd_rw_node <= out_port(LCD_RW_POS);
				lcd_rs_node <= out_port(LCD_RS_POS);
				access4bit <= out_port(ACCESS4BIT_POS);
			end if;
		end if;
	end process;
	lcd_rw <= lcd_rw_node;
	lcd_rs <= lcd_rs_node;
	
	-- o̓|[g1if[^b`j
	process(reset, clk) begin
		if reset='1' then
			wr_data <= (others => '0');
		elsif clk'event and clk='1' then
			if write_strobe='1' and port_id=1 then
				wr_data <= out_port;
			end if;
		end if;
	end process;
	
	process(reset, clk) begin
		if reset='1' then
			port1_w_strobe <= '0';
		elsif clk'event and clk='1' then
			if write_strobe='1' then
				if port_id=1 then
					port1_w_strobe <= '1';
				else
					port1_w_strobe <= '0';
				end if;
			else
				port1_w_strobe <= '0';
			end if;
		end if;
	end process;
	
	-- o̓|[g2iC^[o^C}[jƂ肠12rbgJE^ŗƂĂāA15ms8rbg183ɂB
	process(reset, clk) begin
		if reset='1' then
			pre_cnt(pre_cnt'LEFT downto 1) <= (others => '0');
			pre_cnt(0) <= '1'; -- ŏ0int_cnt_EJEĝ
		elsif clk'event and clk='1' then
			if int_cnt/=0 then -- int_cnt0܂ŃJEg
				pre_cnt <= pre_cnt + 1;
			else
			   pre_cnt(pre_cnt'LEFT downto 1) <= (others => '0');
			   pre_cnt(0) <= '1'; -- ŏ0int_cnt_EJEĝ
			end if;
		end if;
	end process;
	
	process(reset, clk) begin
		if reset='1' then
			int_cnt <= (others => '0');
		elsif clk'event and clk='1' then
			if write_strobe='1' and port_id=2 then
				int_cnt <= out_port;
			elsif int_cnt/=0 and pre_cnt=0 then -- int_cnt0ɂȂ܂ŃC^[o^C}[JEg
				int_cnt <= int_cnt - 1;
			end if;
		end if;
	end process;
	int_cnt_is_zero <= '1' when int_cnt=0 else '0';
	
	-- o̓|[g3 (right_ack)
	right_ack <= '1' when write_strobe='1' and port_id=3 else '0';
	
	-- o̓|[g4 (left_ack)
	left_ack <= '1' when write_strobe='1' and port_id=4 else '0';
	
	-- ̓|[g0A
	process(reset, clk) begin
		if reset='1' then
			input_data_latch <= (others => '0');
		elsif clk'event and clk='1' then
			if lcd_rw_node='1' and ope_is_idle='0' and sel_lower='0' then -- read[hőpXe[g}VNĂāAupperju̎
				input_data_latch(7 downto 4) <= lcd_d(7 downto 4);
			elsif lcd_rw_node='1' and ope_is_idle='0' and sel_lower='1' then -- read[hőpXe[g}VNĂāAlowerju̎
				input_data_latch(3 downto 0) <= lcd_d(7 downto 4);
			end if;
		end if;
	end process;
	
	-- ̓|[gp̃ZN^
	process(input_data_latch, upper_4hex_data, lower_4hex_data, port_id, read_strobe, ope_is_idle, int_cnt_is_zero) begin
		if read_strobe='1' then
			case port_id is
				when X"00" =>
					in_port <= input_data_latch;
				when X"01" => 
					in_port <= "000000"& ope_is_idle & int_cnt_is_zero;
				when X"02" =>
					in_port <= upper_4hex_data(15 downto 8);
				when X"03" =>
					in_port <= upper_4hex_data(7 downto 0);
				when X"04" =>
					in_port <= lower_4hex_data(15 downto 8);
				when X"05" =>
					in_port <= lower_4hex_data(7 downto 0);
				when others => -- 6
					in_port <= cursor_position &'0' & cursor_move & left_level & right_level;
			end case;
		else
			in_port <= "--------";
		end if;
	end process;
		
	-- o̓|[gɏo͂邽߂4rbgɂ邽߂̃}`vNT
	process(wr_data, sel_lower) begin
		if sel_lower='0' then -- upper
			lcd_d_node <= wr_data(7 downto 4);
		else -- lower
			lcd_d_node <= wr_data(3 downto 0);
		end if;
	end process;
	
	-- lcd_d̏o̓Cl[u
	lcd_d <= lcd_d_node when lcd_rw_node='0' else (others => 'Z');
end RTL;
	