--  C:\HDL\FNDISEWORK\SAMPLE\...\ROTSW_SM.vhd
--  VHDL code created by Xilinx's StateCAD 8.1i
--  Sat May 20 06:07:18 2006

--  This VHDL code (for use with IEEE compliant tools) was generated using: 
--  enumerated state assignment with structured code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are speed optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY ROTSW_SM IS
	PORT (CLK,RESET,rot_center_node,Switch_A,Switch_B: IN std_logic;
		center_pulse,left_pulse,right_pulse : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF ROTSW_SM IS
	TYPE type_sreg IS (idle,Switch_A_B_On,Switch_A_On,Switch_B_A_On,Switch_B_On,
		Switch_Holdoff);
	SIGNAL sreg, next_sreg : type_sreg;
	TYPE type_sreg1 IS (center_p_high,cnter_p_holdoff,idle_center_p);
	SIGNAL sreg1, next_sreg1 : type_sreg1;
	SIGNAL next_center_pulse,next_left_pulse,next_right_pulse : std_logic;
BEGIN
	PROCESS (CLK, RESET, next_sreg, next_left_pulse, next_right_pulse)
	BEGIN
		IF ( RESET='1' ) THEN
			sreg <= idle;
			left_pulse <= '0';
			right_pulse <= '0';
		ELSIF CLK='1' AND CLK'event THEN
			sreg <= next_sreg;
			left_pulse <= next_left_pulse;
			right_pulse <= next_right_pulse;
		END IF;
	END PROCESS;

	PROCESS (CLK, RESET, next_sreg1, next_center_pulse)
	BEGIN
		IF ( RESET='1' ) THEN
			sreg1 <= idle_center_p;
			center_pulse <= '0';
		ELSIF CLK='1' AND CLK'event THEN
			sreg1 <= next_sreg1;
			center_pulse <= next_center_pulse;
		END IF;
	END PROCESS;

	PROCESS (sreg,sreg1,rot_center_node,Switch_A,Switch_B)
	BEGIN
		next_center_pulse <= '0'; next_left_pulse <= '0'; next_right_pulse <= '0'; 

		next_sreg<=idle;
		next_sreg1<=center_p_high;

		CASE sreg IS
			WHEN idle =>
				IF ( Switch_A='0' AND Switch_B='1' ) THEN
					next_sreg<=Switch_B_On;
					next_right_pulse<='0';
					next_left_pulse<='0';
				END IF;
				IF ( Switch_A='1' AND Switch_B='0' ) THEN
					next_sreg<=Switch_A_On;
					next_right_pulse<='0';
					next_left_pulse<='0';
				END IF;
				IF ( Switch_B='0' AND Switch_A='0' ) OR ( Switch_A='1' AND Switch_B='1' )
					 THEN
					next_sreg<=idle;
					next_right_pulse<='0';
					next_left_pulse<='0';
				END IF;
			WHEN Switch_A_B_On =>
				next_sreg<=Switch_Holdoff;
				next_right_pulse<='0';
				next_left_pulse<='0';
			WHEN Switch_A_On =>
				IF ( Switch_B='1' ) THEN
					next_sreg<=Switch_A_B_On;
					next_right_pulse<='1';
					next_left_pulse<='0';
				 ELSE
					next_sreg<=Switch_A_On;
					next_right_pulse<='0';
					next_left_pulse<='0';
				END IF;
			WHEN Switch_B_A_On =>
				next_sreg<=Switch_Holdoff;
				next_right_pulse<='0';
				next_left_pulse<='0';
			WHEN Switch_B_On =>
				IF ( Switch_A='1' ) THEN
					next_sreg<=Switch_B_A_On;
					next_right_pulse<='0';
					next_left_pulse<='1';
				 ELSE
					next_sreg<=Switch_B_On;
					next_right_pulse<='0';
					next_left_pulse<='0';
				END IF;
			WHEN Switch_Holdoff =>
				IF ( Switch_A='0' AND Switch_B='0' ) THEN
					next_sreg<=idle;
					next_right_pulse<='0';
					next_left_pulse<='0';
				 ELSE
					next_sreg<=Switch_Holdoff;
					next_right_pulse<='0';
					next_left_pulse<='0';
				END IF;
			WHEN OTHERS =>
		END CASE;

		CASE sreg1 IS
			WHEN center_p_high =>
				next_sreg1<=cnter_p_holdoff;
				next_center_pulse<='0';
			WHEN cnter_p_holdoff =>
				IF ( rot_center_node='0' ) THEN
					next_sreg1<=idle_center_p;
					next_center_pulse<='0';
				 ELSE
					next_sreg1<=cnter_p_holdoff;
					next_center_pulse<='0';
				END IF;
			WHEN idle_center_p =>
				IF ( rot_center_node='1' ) THEN
					next_sreg1<=center_p_high;
					next_center_pulse<='1';
				 ELSE
					next_sreg1<=idle_center_p;
					next_center_pulse<='0';
				END IF;
			WHEN OTHERS =>
		END CASE;
	END PROCESS;
END BEHAVIOR;
