-- LCD4HexDisp̃eXgp

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Test_LCD4HexDisp is
	port(
		clk : in std_logic;
		reset : in std_logic;
		lcd_d : inout std_logic_vector(7 downto 4);
		lcd_rs : out std_logic;
		lcd_rw : out std_logic;
		lcd_e : out std_logic;
		sf_ce0 : out std_logic;
		rot_a : in std_logic;
		rot_b : in std_logic;
		rot_center : in std_logic;
		DDR_read_data : in std_logic_vector(15 downto 0);
		DDR_write_data : out std_logic_vector(15 downto 0)
	);
end Test_LCD4HexDisp;

architecture RTL of Test_LCD4HexDisp is
component LCD4HexDisp
	port(
		clk : in std_logic;
		reset : in std_logic;
		upper_4hex_data : in std_logic_vector(15 downto 0); -- LCD̍s416i
		lower_4hex_data : in std_logic_vector(15 downto 0); -- LCD̍s416i
		lcd_d : inout std_logic_vector(7 downto 4);
		lcd_rs : out std_logic;
		lcd_rw : out std_logic;
		lcd_e : out std_logic;
		right_level : in std_logic; -- rightpXBright_ack܂1̂܂
		right_ack : out std_logic;
		left_level : in std_logic; -- leftpXBleft_ack܂1̂܂
		left_ack : out std_logic;
		cursor_position : in std_logic_vector(3 downto 0); -- J[\̈ʒuoCiŎBԍ3
		cursor_move : in std_logic; -- 0̎J[\̈ړA1̎w肳ꂽJEgAbvA_E
		cursor_return : out std_logic -- PicoBlazeJ[\[ɖ߂
	);
end component;
component input_4hex_top
	port(
		clk : in std_logic;
		reset : in std_logic;
		rot_a : in std_logic;
		rot_b : in std_logic;
		rot_center : in std_logic;
		right_level : out std_logic; -- rightpXBright_ack܂1̂܂
		right_ack : in std_logic;
		left_level : out std_logic; -- leftpXBleft_ack܂1̂܂
		left_ack : in std_logic;
		cursor_move: out std_logic; -- 0̎J[\̈ړA1̎w肳ꂽJEgAbvA_E
		cursor_position : out std_logic_vector(3 downto 0); -- J[\̈ʒuoCiŎBԍ3
		cursor_return : in std_logic; -- PicoBlazeJ[\[ɖ߂
		upper_4hex_data : out std_logic_vector(15 downto 0) -- LCD̍s416i
	);
end component;
signal upper_4hex_data : std_logic_vector(15 downto 0); -- LCD̍s416i
signal lower_4hex_data : std_logic_vector(15 downto 0); -- LCD̍s416i
signal right_level : std_logic; -- rightpXBright_ack܂1̂܂
signal right_ack : std_logic;
signal left_level : std_logic; -- leftpXBleft_ack܂1̂
signal left_ack : std_logic;
signal cursor_move : std_logic; -- 1̎J[\̈ړA0̎w肳ꂽJEgAbvA_E
signal cursor_return : std_logic; -- PicoBlazeJ[\[ɖ߂
signal cursor_position : std_logic_vector(3 downto 0);

begin
	sf_ce0 <= '1';
	lower_4hex_data <= DDR_read_data;
	DDR_write_data <= upper_4hex_data;
	
	LCD4HexDisp_inst : LCD4HexDisp port map(
		clk => clk,
		reset => reset,
		upper_4hex_data => upper_4hex_data,
		lower_4hex_data => lower_4hex_data,
		lcd_d => lcd_d,
		lcd_rs => lcd_rs,
		lcd_rw => lcd_rw,
		lcd_e => lcd_e,
		right_level => right_level,
		right_ack => right_ack,
		left_level => left_level,
		left_ack => left_ack,
		cursor_move => cursor_move,
		cursor_position => cursor_position,
		cursor_return => cursor_return
	);
	
	input_4hex_top_inst : input_4hex_top port map(
		clk => clk,
		reset => reset,
		rot_a => rot_a,
		rot_b => rot_b,
		rot_center => rot_center,
		right_level => right_level,
		right_ack => right_ack,
		left_level => left_level,
		left_ack => left_ack,
		cursor_move => cursor_move,
		cursor_position => cursor_position,
		cursor_return => cursor_return,
		upper_4hex_data => upper_4hex_data
	);
end RTL;
