-- addr_fifo.vhd
-- AhXێĂFIFOBdoutnext_douto͂Aempty=0, almost_empty=1̎́AdoutL
-- empty=0, almost_empty=0̎doutnext_doutƂLB邱ƂɂāAdoutnext_doutrł
-- o[Xgł邩ǂB
-- 64DepthFIFOō邱ƂɂBRAM64X1Dgp
-- Read_WriteV݁Arw_out, next_rw_outV

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

-- pragma translate_off
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
-- pragma translate_on
--
library work;
use work.ddr_controller_pack.all;

entity addr_fifo is
	port(
		clk : in std_logic;
		reset : in std_logic;
		din : in std_logic_vector(USER_INPUT_ADDRESS_WIDTH-1 downto 0);
		read_write : in std_logic;
		wr_en : in std_logic;
		rd_en : in std_logic;
		dout : out std_logic_vector(USER_INPUT_ADDRESS_WIDTH-1 downto 0);
		rw_out : out std_logic; -- read/write output
		full : out std_logic;
		empty : out std_logic;
		next_dout : out std_logic_vector(USER_INPUT_ADDRESS_WIDTH-1 downto 0);
		next_rw_out : out std_logic; -- next read/write output
		almost_empty : out std_logic;
		almost_full : out std_logic
	);
end addr_fifo;

architecture RTL of addr_fifo is
component RAM16X1D
  generic (
    INIT : bit_vector := X"0000"
    );

  port (
    DPO : out std_ulogic;
    SPO : out std_ulogic;

    A0    : in std_ulogic;
    A1    : in std_ulogic;
    A2    : in std_ulogic;
    A3    : in std_ulogic;
    D     : in std_ulogic;
    DPRA0 : in std_ulogic;
    DPRA1 : in std_ulogic;
    DPRA2 : in std_ulogic;
    DPRA3 : in std_ulogic;
    WCLK  : in std_ulogic;
    WE    : in std_ulogic
    );
end component;

signal wp, rp : std_logic_vector(3 downto 0);
signal out_sig, outff1, outff2 : std_logic_vector(USER_INPUT_ADDRESS_WIDTH-1 downto 0);
signal outff1_flag, outff2_flag : std_logic;
signal we : std_logic;
signal fifo_full, fifo_empty : std_logic;
signal inner_rd_en : std_logic;
signal out_rw, rwff1, rwff2 : std_logic;
begin
	FIFO_GEN : for i in USER_INPUT_ADDRESS_WIDTH-1 downto 0 generate
		RAM16_INST : RAM16X1D port map(
			DPO => out_sig(i),
			SPO => open,
			A0 => wp(0),
			A1 => wp(1),
			A2 => wp(2),
			A3 => wp(3),
			D => din(i),
			DPRA0 => rp(0),
			DPRA1 => rp(1),
			DPRA2 => rp(2),
			DPRA3 => rp(3),
			WCLK => clk,
			WE => we
		);
	end generate FIFO_GEN;
	we <= wr_en and not fifo_full;
	
	Inst_FIFO_WR : RAM16X1D port map(
		DPO => out_rw,
		SPO => open,
		A0 => wp(0),
		A1 => wp(1),
		A2 => wp(2),
		A3 => wp(3),
		D => read_write,
		DPRA0 => rp(0),
		DPRA1 => rp(1),
		DPRA2 => rp(2),
		DPRA3 => rp(3),
		WCLK => clk,
		WE => we
	);
	
	process(reset, clk) begin -- wp, rp
		if reset='1' then
			wp <= (others => '0');
			rp <= (others => '0');
		elsif clk'event and clk='1' then
			if wr_en='1' and fifo_full='0' then -- wr_en1ŁAFIFOtłȂƂɏ
				wp <= wp + 1;
			end if;
			if inner_rd_en='1' and fifo_empty='0' then -- rd_en1ŁAFIFOemptyoȂɓǂݏo
				rp <= rp + 1;
			end if;
		end if;
	end process;
	fifo_full <= '1' when rp-1 = wp else '0'; -- rp1wptB1GggȂ傤Ȃ
	full <= fifo_full;
	almost_full <= '1' when rp-2 = wp else '0';
	fifo_empty <= '1' when rp = wp else '0'; -- rp = wp̎ɁAFIFO͋
	
	process(reset, clk) begin -- outff1
		if reset='1' then
			outff1 <= (others => '0');
			rwff1 <= '0';
		elsif clk'event and clk='1' then
			if fifo_empty='0' and (not(rd_en='0' and outff1_flag='1' and outff2_flag='1')) then
			-- FIFOłȂAoutff1,outff2ςœǂݏołȂȊOoutff1FIFO̓eǂݏoB
				outff1 <= out_sig;
				rwff1 <= out_rw;
			end if;
		end if;
	end process;
	inner_rd_en <= '1' when fifo_empty='0' and (not(rd_en='0' and outff1_flag='1' and outff2_flag='1')) else '0';
	
	process(reset, clk) begin -- outff2
		if reset='1' then
			outff2 <= (others => '0');
			rwff2 <= '0';
		elsif clk'event and clk='1' then
			if outff1_flag='1' and (outff2_flag='0' or (outff2_flag='1' and rd_en='1')) then
			-- outff1Ƀf[^āAoutff2Ƀf[^ĂȂAĂĂǂݏoƂɃf[^
				outff2 <= outff1;
				rwff2 <= rwff1;
			end if;
		end if;
	end process;
	
	process(reset, clk) begin -- outff1_flag
		if reset='1' then
			outff1_flag <= '0';
		elsif clk'event and clk='1' then
			if inner_rd_en='1' then
				outff1_flag <= '1';
			elsif outff2_flag='0' or rd_en='1' then -- inner_rd_en0Ȃ̂ŁAoutff2󂩁AǂݏoꂽoutffVtgꂽ̂0
				outff1_flag <= '0';
			end if;
		end if;
	end process;
	
	process(reset, clk) begin -- outff2_flag
		if reset='1' then
			outff2_flag <= '0';
		elsif clk'event and clk='1' then
			if outff1_flag='1' and (outff2_flag='0' or (outff2_flag='1' and rd_en='1')) then
			-- outff1Ƀf[^āAoutff2Ƀf[^ĂȂAĂĂǂݏoƂɃf[^
				outff2_flag <= '1';
			elsif outff1_flag='0' and rd_en='1' then -- ̃f[^ȂāAf[^ǂݏoꂽ0
				outff2_flag <= '0';
			end if;
		end if;
	end process;
	
	empty <= not outff2_flag;
	almost_empty <= '1' when outff2_flag='0' or (outff2_flag='1' and outff1_flag='0') else '0';
	next_dout <= outff1;
	dout <= outff2;
	next_rw_out <= rwff1;
	rw_out <= rwff2;
end RTL;

			