-- Read Data Module
-- ReadDDR SDRAM̃f[^󂯂
-- DQzxAZbgAbvԂ𑍌vĎ3/4炷Bclknot clkŃf[^TvłB

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;
--
-- pragma translate_off
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
-- pragma translate_on
--
library work;
use work.ddr_controller_pack.all;

entity read_data_module is
	port(
		reset : in std_logic;
		clk : in std_logic;
		clkx : in std_logic;
		read_timing : in std_logic;
		burst_read : in std_logic;
		rddata_fifo_data : out std_logic_vector(INTERFACE_DATA_WIDTH-1 downto 0);
		rddata_fifo_wren : out std_logic;
		rddata_fifo_full : in std_logic;
		rddata_fifo_almost_full : in std_logic;
		
		ddr_dq : in std_logic_vector(DDR_DATA_WIDTH-1 downto 0);
		ddr_dqs : in std_logic_vector(DDR_DQS_DM_WIDTH-1 downto 0)
	);
end read_data_module;

architecture RTL of read_data_module is
signal rddata_fifo_wren_node0, rddata_fifo_wren_node1 : std_logic;
signal dq_rise , dq_fall : std_logic_vector(DDR_DATA_WIDTH-1 downto 0);
signal dqs_rise , dqs_fall : std_logic;
signal dq_rise_1d , dq_fall_1d : std_logic_vector(DDR_DATA_WIDTH-1 downto 0);
signal dq_rise_2d , dq_fall_2d : std_logic_vector(DDR_DATA_WIDTH-1 downto 0);
begin
	
	-- ͗pDDRWX^̐
	process(clk, ddr_dq, reset) begin -- DQIOBDDRWX^𐄒肳
		if reset='1' then
			dq_rise <= (others => '0');
		elsif clk'event and clk='1' then -- 
			dq_rise <= ddr_dq;
		end if;
	end process;
	process(clk, ddr_dq, reset) begin
		if reset='1' then
			dq_fall <= (others => '0');
		elsif clk'event and clk='0' then -- 
			dq_fall <= ddr_dq;
		end if;
	end process;
	
	process(clkx, reset) begin -- f[^1/4点čŏ̃f[^ŃTv
		if reset='1' then
			dq_rise_1d <= (others => '0');
			dq_fall_1d <= (others => '0');
			rddata_fifo_wren_node0 <= '0';
		elsif clkx'event and clkx='1' then
			dq_rise_1d <= dq_rise;
			dq_fall_1d <= dq_fall;
			rddata_fifo_wren_node0 <= read_timing;
		end if;
	end process;
	
	process(clk, reset) begin -- f[^clkxclkɏ悹
		if reset='1' then
			dq_rise_2d <= (others => '0');
			dq_fall_2d <= (others => '0');
			rddata_fifo_wren_node1 <= '0';
		elsif clk'event and clk='1' then
			dq_rise_2d <= dq_rise_1d;
			dq_fall_2d <= dq_fall_1d;
			rddata_fifo_wren_node1 <= rddata_fifo_wren_node0;
		end if;
	end process;
	
	rddata_fifo_data <= dq_rise_2d & dq_fall_2d;-- ŏɏoĂ(fall)O[h(gEGfBAj
	rddata_fifo_wren <= rddata_fifo_wren_node1;
end RTL;
	