-- LCD̓͗p̏̌̃f[^ێ
-- [^[EGR[_[̃Rg[right pulse, left pulse󂯂ƂB
-- [h2Move[hiɂ͂̃[hj̎right pulseɂ̓J[\EɈړBleft pulseɂ̓J[\ɈړB
-- ۂɃJ[\𓮂̂PicoBlazẽW[ł́A20nspulsePicoBlazeFł镝̃pXɂ邽߂PicoBlazeƃnhVF[N
-- Count[hłright pulseɂ1JEgAbvAleft pulseɂ1JEg_EB
-- Move[h,Count[h؂ւcenter_pulseōsB

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity input_4hex_val is
	port(
		clk : in std_logic;
		reset : in std_logic;
		right_pulse : in std_logic;
		left_pulse : in std_logic;
		center_pulse : in std_logic; -- [^[EGR[_̃XCb`pX
		right_level : out std_logic; -- rightpXBright_ack܂1̂܂
		right_ack : in std_logic;
		left_level : out std_logic; -- leftpXBleft_ack܂1̂܂
		left_ack : in std_logic;
		cursor_move : out std_logic; -- 1̎J[\̈ړA0̎w肳ꂽJEgAbvA_E
		cursor_position : out std_logic_vector(3 downto 0); -- J[\̈ʒuoCiŎBԍ3
		cursor_return : in std_logic; -- PicoBlazeJ[\[ɖ߂
		upper_4hex_data : out std_logic_vector(15 downto 0) -- LCD̍s416i
	);
end input_4hex_val;

architecture RTL of input_4hex_val is
component IN4HEXSM
	PORT (CLK,center_pulse,left_ack,left_pulse,RESET,right_ack,right_pulse: IN 
		std_logic;
		cursor_move,left_level,right_level : OUT std_logic);
END component;

type data_type is array (3 downto 0) of std_logic_vector(3 downto 0);
signal data : data_type;
signal cursor_move_mode : std_logic;
signal count_mode : std_logic;

constant CURSOR_POS_1ST : std_logic_vector := "0001";
constant CURSOR_POS_2ND : std_logic_vector := "0010";
constant CURSOR_POS_3RD : std_logic_vector := "0100";
constant CURSOR_POS_4TH : std_logic_vector := "1000";
signal cur_pos : std_logic_vector(3 downto 0);
begin
	in4hexsm_inst : in4hexsm port map(
		clk => clk,
		reset => reset,
		right_pulse => right_pulse,
		left_pulse => left_pulse,
		right_ack => right_ack,
		left_ack => left_ack,
		center_pulse => center_pulse,
		cursor_move => cursor_move_mode,
		left_level => left_level,
		right_level => right_level
	);
	cursor_move <= cursor_move_mode;
	count_mode <= not cursor_move_mode;
	
	process(reset, clk) begin -- ݂̃J[\̈ʒu
		if reset='1' then
			cur_pos <= CURSOR_POS_4TH;
		elsif clk'event and clk='1' then
			if cursor_return='1' then -- f[^ÎŃJ[\[ɖ߂
				cur_pos <= CURSOR_POS_1ST;
			elsif cursor_move_mode='1' then -- cursor move[h̎
				case cur_pos is
					when CURSOR_POS_1ST =>
						if right_pulse='1' then -- ԉËʒuȂ̂ł̂܂
							cur_pos <= CURSOR_POS_1ST;
						elsif left_pulse='1' then -- 1
							cur_pos <= CURSOR_POS_2ND;
						end if;
					when CURSOR_POS_2ND =>
						if right_pulse='1' then -- 1E
							cur_pos <= CURSOR_POS_1ST;
						elsif left_pulse='1' then -- 1
							cur_pos <= CURSOR_POS_3RD;
						end if;
					when CURSOR_POS_3RD =>
						if right_pulse='1' then -- 1E
							cur_pos <= CURSOR_POS_2ND;
						elsif left_pulse='1' then -- 1
							cur_pos <= CURSOR_POS_4TH;
						end if;
					when others => -- CURSOR_POS_4TH
						if right_pulse='1' then -- 1E
							cur_pos <= CURSOR_POS_3RD;
						elsif left_pulse='1' then -- 1Ӎ̈ʒuȂ̂ł̂܂
							cur_pos <= CURSOR_POS_4TH;
						end if;
				end case;
			end if;
		end if;
	end process;
	
	cursor_position <= "0011" when cur_pos=CURSOR_POS_4TH else
				"0010" when cur_pos=CURSOR_POS_3RD else
				"0001" when cur_pos=CURSOR_POS_2ND else "0000";
	
	process(reset, clk) begin -- JE^̎
		for i in 3 downto 0 loop
			if reset='1' then
				data(i) <= (others => '0');
			elsif clk'event and clk='1' then
				if cur_pos(i)='1' and count_mode='1' then -- IĂāAJEg[h
					if right_pulse='1' then -- Eɉ񂵂Ƃ+1
						data(i) <= data(i) + 1;
					elsif left_pulse='1' then -- ɉ񂵂Ƃ-1
						data(i) <= data(i) - 1;
					end if;
				end if;
			end if;
		end loop;
	end process;
	
	upper_4hex_data <= data(3) & data(2) & data(1) & data(0);
end RTL;
